// BASSmix Simple Console Test
// Copyright (c) 2005 Sebastian Andersson

#include <stdio.h>
#include <stdlib.h>
#include "bass.h"
#include "bassmix.h"

void main(int argc, char **argv)
{
	DWORD chan,time,level;
	int a;
	QWORD pos;

	printf("Simple console mode BASSmix example : AIFF/MPx/OGG/WAV mixer/player\n"
		"-------------------------------------------------------------------\n");

	// check that BASS 2.2 was loaded
	if (BASS_GetVersion()!=MAKELONG(2,2)) {
		printf("BASS version 2.2 was not loaded\n");
		return;
	}

	if (argc<4) {
		printf("usage: %s <freq> <chans> <file1> <file2> ...\n",argv[0]);
		return;
	}

	if (!BASS_Init(-1,44100,0,0,NULL)) {
		printf("error: can't open output device\n");
		return;
	}

	if (!(chan=BASS_Mixer_StreamCreate(atol(argv[1]),atol(argv[2]),0))) {
		printf("error: can't create mixer output\n");
		BASS_Free();
		return;
	}

	printf("mixing/streaming files...\n");
	for (a=3;a<argc;a++) {
		// insert channels into mixer
		if (BASS_Mixer_StreamAddChannel(chan,BASS_StreamCreateFile(FALSE,argv[a],0,0,BASS_SAMPLE_FLOAT|BASS_SAMPLE_LOOP|BASS_STREAM_DECODE),0))
			printf("\t%s\n",argv[a]);
	}
	printf("\n");

	BASS_ChannelPlay(chan,FALSE);

	while (!_kbhit() && BASS_ChannelIsActive(chan)) {
		// display some stuff and wait a bit
		level=BASS_ChannelGetLevel(chan);
		pos=BASS_ChannelGetPosition(chan);
		time=BASS_ChannelBytes2Seconds(chan,pos);
		printf("pos %09I64u",pos);
		printf(" - %u:%02u - L ",time/60,time%60);
		{
			for (a=27204;a>200;a=a*2/3) putchar(LOWORD(level)>=a?'*':'-');
			putchar(' ');
			for (a=210;a<32768;a=a*3/2) putchar(HIWORD(level)>=a?'*':'-');
		}
		printf(" R - cpu %.2f%%  \r",BASS_GetCPU());
		fflush(stdout);
		Sleep(50);
	}
	printf("                                                                             \r");

	// wind the frequency down...
	BASS_ChannelSlideAttributes(chan,1000,-1,-101,500);
	Sleep(300);
	// ...and fade-out to avoid a "click"
	BASS_ChannelSlideAttributes(chan,-1,-2,-101,200);
	while (BASS_ChannelIsSliding(chan)) Sleep(1);

	BASS_Free();
}
